//********************************************************************
//*** ResourcePool/SQL/Resource.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: Resource.cc,v 1.8 2008/06/02 07:22:35 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "ResourcePool/SQL/Resource.hh"

namespace fatalmind {
namespace SQL {

template<class TM>
SQLResource<TM>::SQLResource()
{
}

template<class TM>
SQLResource<TM>::~SQLResource()
{
}

template<class TM>
DummySQLResource<TM>::DummySQLResource()
{
}


template<class TM, class RT>
SQLResourceSpecialized<TM, RT>::SQLResourceSpecialized(RT* a_resource)
: resource_(a_resource)
, resource_ref(*resource_)
{
}

template<class TM, class RT>
SQLResourceSpecialized<TM, RT>::SQLResourceSpecialized(RT& a_resource)
: resource_()
, resource_ref(a_resource)
{
}

template<class TM, class RT>
SQLResourceSpecialized<TM, RT>::~SQLResourceSpecialized()
{
}

template<class TM, class RT>
bool SQLResourceSpecialized<TM, RT>::precheck()
{
	return resource_ref.precheck();
}

template<class TM, class RT>
bool SQLResourceSpecialized<TM, RT>::postcheck()
{
	return resource_ref.postcheck();
}

template<class TM, class RT>
void SQLResourceSpecialized<TM, RT>::close()
{
	resource_ref.close();
}

template<class TM, class RT>
void SQLResourceSpecialized<TM, RT>::fail_close()
{
	return resource_ref.fail_close();
}

template<class TM, class RT>
std::string SQLResourceSpecialized<TM, RT>::getSessionID() const
{
	return resource_ref.getSessionID();
}


} // namespace SQL
} // namespace fatalmind


