//********************************************************************
//*** ResourcePool/oracle/ResourceFwd.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: ResourceFwd.hh,v 1.9 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_RESOURCEFWD_HH
#define RESOURCEPOOL_ORACLE_RESOURCEFWD_HH

#ifndef CACHE_CACHE_HH
#include "cache/Cache.hh"
#endif

namespace fatalmind {
namespace oracle {


class SelectListMetaData;
class SelectListMetaDataCtor;

template<class TM>
struct SelectListMetaDataCacheInterface
{
	typedef CacheInterface<std::string
		, SelectListMetaData
		, SelectListMetaDataCtor
		, LeastRecentlyUsedExpirationPolicy
		, TM> type;
};

template<class TM>
struct SelectListMetaDataCache
{
	typedef Cache<std::string
		, SelectListMetaData
		, SelectListMetaDataCtor
		, LeastRecentlyUsedExpirationPolicy
		, TM> type;
};

template<class TM>
struct SelectListMetaDataNopCache
{
	typedef NopCache<std::string
		, SelectListMetaData
		, SelectListMetaDataCtor
		, LeastRecentlyUsedExpirationPolicy
		, TM> type;
};

template<class TM = DefaultThreadedModel, template<class>class SLMDC = oracle::SelectListMetaDataCache >
class ResourceType;

} // namespace oracle

class oracleHandles;

template<class TM>
class oracleHandlesWithCache;

template<class TM>
class oracleResource;

} // namespace fatalmind

#endif

